#!/usr/bin/env python
# -*- encoding: utf-8 -*-
'''
@Contact :   liuyuqi.gov@msn.cn
@Time    :   2022/02/23 04:21:56
@License :   Copyright © 2017-2020 liuyuqi. All Rights Reserved.
@Desc    :   crawl xiaohua.com
'''

from flask import Flask
import sys
from crawl_xiaohua.crawl_xiaohua import CrawlXiaohua
from crawl_xiaohua.extractor.mzsock import Mzsock
from crawl_xiaohua.extractor.xiaohuar import Xiaohuar
from flask import Flask

class CrawlXiaohua():
    ''' crawl xiaohua '''

    def __init__(self):
        ''' init '''
        pass
        
    def server(self, config: str, argv=None):
        ''' web server mode '''
        if argv is None:
            argv = sys.argv
        else:
            sys.argv.extend(argv)
        app = Flask(__name__,
                    static_folder='web/static',
                    template_folder='web/templates')
        app.run()


    def run(self, extractor: str, cmd: str, argv=None):
        ''' shell mode '''
        if argv is None:
            argv = sys.argv
        if extractor == 'xiaohua':
            crawl = CrawlXiaohua()
            if cmd == 'duanzi':
                crawl.crawlDuanzi()
            else:
                crawl.crawl()
        elif extractor == 'xiaohuar':
            crawl = Xiaohuar()
            crawl.run()
        elif extractor == 'mzsock':
            crawl = Mzsock()
            categroy_urls = crawl.get_categroy_url()
            urllist = crawl.get_urllist(categroy_urls)
            contentlist = crawl.get_contentlist(urllist)
            crawl.get_content(contentlist)
        else:
            print('unknown extractor: %s' % extractor)
